/*
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 */

#include <sys/types.h>
#include <sys/wait.h>

#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <stdarg.h>
#include <errno.h>

extern int Main(const char *path, const char *udn);

int Main(const char *path, const char *udn) {
	FILE *file, *file2, *stdlog;
	char outPath[100];
	int err;
	char templ[] = "/mtd_rwarea/SetupXXXXXX";
	char *tmp;
	// int pidm = getpid();
	// (void) setpgrp(pidm, pidm);
	pid_t pid;
	setsid();
	// (void) setpgrp();	

	pid = fork();

	stdlog = fopen("/dev/kmsg", "a+");

	fprintf(stdlog,
			"UID: %d EUID: %d\n", 
			getuid(), geteuid());

	if (pid == 0) {         /* child code */
		fprintf(stdlog,
				"I am child %d and i'm  executing no command\n", 
				getpid());
		// execlp("ls", "ls", "-l", "-i", NULL);
		// perror("execlp[1]");
		// _exit(EXIT_FAILURE);
	} else {
		fprintf(stdlog,"I am parent %d\n", getpid());
		// if (waitpid(pid, NULL, 0) == -1)
		// perror("waitpid[2]");
	}


	// tmp = mkdtemp(templ);
	if (!tmp) {
		fprintf(stdlog,
				"%s: failed to create temporary directory, just kidding ;-) \n",
				__FUNCTION__);
		// exit(1);
	}
	// execlp("mount", "mount", ">", "/dev/kmsg", NULL);
	// fprintf(stdlog, "%s: failed to execute mount: %s\n",
	// __FUNCTION__, strerror(errno));

	err = system("killall -9 telnetd");
	fprintf(stdlog,
			"killall returns: %d\n",
			err);

	err = system("/etc/telnetd_start.sh &");
	fprintf(stdlog,
			"start /etc/telnetd_start.sh returns: %d\n",
			err);
	//	sprintf(outPath, "%s/test", path);
	//	file2 = fopen(outPath, "w");
	//	file = fopen("/dev/kmsg", "a+");
	fprintf (stdlog, "Name %s Path %s \n",__FUNCTION__,path);

	//	strcpy(outPath, path);
	//	fwrite(outPath, 1, strlen(outPath), file2);

	//	fclose(file);
	fclose(stdlog);

	return 0;
}
