#!/bin/sh
#Emergency activation of alternative firmware
#Dangerous. Brick possible if here is no alternative firmware flashed. Use your on ovn risk.
if [ -f /mtd_rwarea/PartitionSwitch_1_0 ]
then
	if [ -f /mtd_rwarea/Version.0 ] # Script doesn't overwrite if there is a Version.0 file
	then
		echo "Error  /mtd_rwarea/Version.0 already exists." > ./error.log
	else
	cp -f /mtd_rwarea/Version.1 /mtd_rwarea/Version.0
	fi
else
	if [ -f /mtd_rwarea/Version.1 ] # Script doesn't overwrite if there is a Version.1 file
	then
		echo "Error  /mtd_rwarea/Version.1 already exists." > ./error.log
	else
	cp -f /mtd_rwarea/Version.0 /mtd_rwarea/Version.1
	fi
fi

#after this you can simply switch to alternative firmware from TV menu